/*
 *$Header: /remet sdk/general/intel_gnrc.h 32    15.03.07 13:02 Kyselgov $ 
*/


#ifdef SHOW_INCLUDES		//if defined, each *.h file message name in output Window
#pragma message ("  {//including "__FILE__)
#endif 


#if !defined (INTEL_GENERAL_CODE_INCLUDED_)
#define INTEL_GENERAL_CODE_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Float.h"

/*!
\addtogroup group_rmtMath_Round 

      :
	- <b>QIfist, _RMT_ROUND_TO_NEAREST</b>.   .
	Microsoft C++ Compiler    MSVS 6.0   MSVS 2005 
	 QIfist      ( float  
	double   )   ANSI  (  ),  
	   (  -   ).
	    round()    -  
	 _RMT_ROUND_TO_NEAREST (,      ).
	- <b>_RMT_ROUND_SAFE</b>.  .
	         
	   ANSI  (QIfist  ).   
	        .

\ingroup group_rmtMath

*/

//#define _RMT_ROUND_SAFE    ,         round(X+0.5);
//#define _RMT_ROUND_SAFE		   //-.       . -  .

const float  FLOAT_MIN  =  FLT_MIN;
const float  FLOAT_MAX  =  FLT_MAX;

/** \addtogroup group_rmtGDI */
/*@{*/

//     
#define F2L round

#define TRUNC (int)

//     
#ifdef _RMT_ROUND_TO_NEAREST

inline int		round(double src)
{
	RMT_ASSERT2(src<=INT_MAX+.5 && src>=INT_MIN-.5,"  %e   .    !",src);
	return int(src);
}

inline int		round(float src)							
{
	//float     / . 
	// 16 000 000     0.5
	//,        double
	RMT_ASSERT2(src<16000000 && src>-16000000,"  %e   .      float   .",src);
	return int(src);
}

inline short	rounds(float src)							
{
	RMT_ASSERT2(src<32767.5f && src>-32768.5f,"  %e  16-bit short int.    !",src);
	return short(src);
}
//inline void		round(float src, size_t &dst)				{dst=size_t(src);}

//     ,   .
//  -   ,          intel_gnrc_unit_test.cpp
//
//inline void		round(float src, int &dst)					{dst=int(src);}
//inline void		round(float src, short &dst)				{dst=short(src);}
//inline void		round(float src, __int64 &dst)				{dst=__int64(src);}

#ifdef _RMT_ROUND_SAFE

//        -6  
inline void roundDn(float src, int &dst)					{dst = round(src-.5f);}
inline void roundUp(float src, int &dst)					{dst =  round(src+.5f);}
inline int roundDn(float src)								{return round(src-.5f);}//   
inline int roundUp(float src)								{return round(src+.5f);}//    

#else  _RMT_ROUND_SAFE

//   
inline void roundDn(float src, int &dst)
{
	RMT_ASSERT((src<=INT_MAX)&&(src>=INT_MIN));
	//dst=int(src);
	WORD oldcw, newcw;
	_asm
	{
		fstcw       oldcw;				//   .	  
		wait			  ;				//    .
		mov         ax,oldcw;			//     .
		and         ah,11110011b;
		or          ah,00000100b;		//   
		mov         newcw,ax;
		fldcw       newcw;				//   
		fld			src;				//  . 
		mov			eax,dst
		fistp		dword ptr [eax];	//      .
		wait;
		fldcw       oldcw;				//     .
	}
}

//   
inline void roundUp(float src, int &dst)
{
	RMT_ASSERT((src<INT_MAX)&&(src>=INT_MIN));
	//dst=int(src)+1;
	WORD oldcw, newcw;
	_asm
	{
		fstcw       oldcw;				//   .	  
		wait			  ;				//    .
		mov         ax,oldcw;			//     .
		and         ah,11110011b;
		or          ah,00001000b;		//   
		mov         newcw,ax;
		fldcw       newcw;				//   
		fld			src;				//  . 
		mov			eax,dst
		fistp		dword ptr [eax];	//      .
		wait;
		fldcw       oldcw;				//     .
	}
}

inline int roundDn(float src)
{
	int dst;
	roundDn(src,dst);
	return dst;
}

inline int roundUp(float src) //  float  int    ()
{
	int dst;
	roundUp(src,dst);
	return dst;
}
#endif _RMT_ROUND_SAFE
#else _RMT_ROUND_TO_NEAREST
#ifdef	_RMT_ROUND_SAFE

inline void  round(float src, int &dst)
{
	RMT_ASSERT((src<=INT_MAX)&&(src>=INT_MIN));
	dst=int(.5f+src);
}
inline void		round(float src, __int64 &dst)
{
	RMT_ASSERT((src<=_I64_MAX)&&(src>=_I64_MIN));
	dst=__int64(.5f+src);
}

inline void		round(float src, short &dst)
{
	RMT_ASSERT((src<=SHRT_MAX)&&(src>=SHRT_MIN));
	dst=short(.5f+src);
}
#else	_RMT_ROUND_SAFE

inline void  round(float src, int &dst)
{
	RMT_ASSERT((src<=INT_MAX)&&(src>=INT_MIN));
	_asm
	{
		fld		src;
		mov		eax,dst
		fistp	dword ptr [eax];
		wait;
	}
}

inline void		round(float src, __int64 &dst)
{
	RMT_ASSERT((src<=_I64_MAX)&&(src>=_I64_MIN));
	_asm
	{
		fld		src;
		mov		eax,dst
		fistp	qword ptr [eax];
		wait;
	}
}

inline void		round(float src, short &dst)
{
	RMT_ASSERT((src<=SHRT_MAX)&&(src>=SHRT_MIN));
	_asm
	{
		fld		src;
		mov		eax,dst
		fistp	word ptr [eax];
		wait;
	}
}

#endif	_RMT_ROUND_SAFE

inline int round(float src)
{
	int dst;
	round(src,dst);
	return dst;
}
#endif  _RMT_ROUND_TO_NEAREST

/*@}*/


#else  
#ifdef SHOW_ALREADY_INCLUDED
#pragma message("... "__FILE__" already included!")
#endif
#endif // !defined (INTEL_GENERAL_CODE_INCLUDED_)

#ifdef SHOW_INCLUDES		//if defined, each *.h file message name in output Window
#pragma message ("  }//included "__FILE__)
#endif 
